Array remove duplicate elements

前端 未结 12 1325
陌清茗
陌清茗 2020-11-27 16:17

I have an unsorted array, what is the best method to remove all the duplicates of an element if present?

e.g:

a[1,5,2,6,8,9,1,1,10,3,2,4,1,3,11,3]


        
相关标签:
12条回答
  • 2020-11-27 16:44
    import java.util.ArrayList;
    import java.util.Arrays;
    import java.util.Collection;
    import java.util.HashMap;
    import java.util.HashSet;
    import java.util.List;
    import java.util.Set;
    
    public class testing {
        public static void main(String[] args) {
            EligibleOffer efg = new EligibleOffer();
            efg.setCode("1234");
            efg.setName("hey");
            EligibleOffer efg1 = new EligibleOffer();
            efg1.setCode("1234");
            efg1.setName("hey1");
            EligibleOffer efg2 = new EligibleOffer();
            efg2.setCode("1235");
            efg2.setName("hey");
            EligibleOffer efg3 = new EligibleOffer();
            efg3.setCode("1235");
            efg3.setName("hey");
            EligibleOffer[] eligibleOffer = { efg, efg1,efg2 ,efg3};
            removeDupliacte(eligibleOffer);
        }
    
        public static EligibleOffer[] removeDupliacte(EligibleOffer[] array) {
            List list = Arrays.asList(array);
            List list1 = new ArrayList();
            int len = list.size();
            for (int i = 0; i <= len-1; i++) {
                boolean isDupliacte = false;
                EligibleOffer eOfr = (EligibleOffer) list.get(i);
                String value = eOfr.getCode().concat(eOfr.getName());
                if (list1.isEmpty()) {
                    list1.add(list.get(i));
                    continue;
                }
                int len1 = list1.size();
                for (int j = 0; j <= len1-1; j++) {
                    EligibleOffer eOfr1 = (EligibleOffer) list1.get(j);
                    String value1 = eOfr1.getCode().concat(eOfr1.getName());
                    if (value.equals(value1)) {
                        isDupliacte = true;
                        break;
                    }
                    System.out.println(value+"\t"+value1);
                }
                if (!isDupliacte) {
                    list1.add(eOfr);
                }
            }
            System.out.println(list1);
            EligibleOffer[] eligibleOffer = new EligibleOffer[list1.size()];
            list1.toArray(eligibleOffer);
            return eligibleOffer;
        }
    }
    
    0 讨论(0)
  • 2020-11-27 16:47

    This can be done in amortized O(n) using a hashtable-based set.

    Psuedo-code:

    s := new HashSet
    c := 0
    for each el in a
      Add el to s.
        If el was not already in s, move (copy) el c positions left.
        If it was in s, increment c. 
    
    0 讨论(0)
  • 2020-11-27 16:47

    My solution(O(N)) does not use additional memory, but array must been sorted(my class using insertion sort algorithm, but it doesn't matter.):

      public class MyArray
            {
                //data arr
                private int[] _arr;
                //field length of my arr
                private int _leght;
                //counter of duplicate
                private int countOfDup = 0;
                //property length of my arr
                public int Length
                {
                    get
                    {
                        return _leght;
                    }
                }
    
                //constructor
                public MyArray(int n)
                {
                    _arr = new int[n];
                    _leght = 0;
                }
    
                // put element into array
                public void Insert(int value)
                {
                    _arr[_leght] = value;
                    _leght++;
                }
    
                //Display array
                public void Display()
                {
                    for (int i = 0; i < _leght; i++) Console.Out.Write(_arr[i] + " ");
                }
    
                //Insertion sort for sorting array
                public void InsertSort()
                {
                    int t, j;
                    for (int i = 1; i < _leght; i++)
                    {
                        t = _arr[i];
                        for (j = i; j > 0; )
                        {
                            if (_arr[j - 1] >= t)
                            {
                                _arr[j] = _arr[j - 1];
                                j--;
                            }
                            else break;
                        }
                        _arr[j] = t;
                    }
                }
    
                private void _markDuplicate()
                {
                    //mark duplicate Int32.MinValue
                    for (int i = 0; i < _leght - 1; i++)
                    {
                        if (_arr[i] == _arr[i + 1])
                        {
                            countOfDup++;
                            _arr[i] = Int32.MinValue;
                        }
                    }
                }
    
                //remove duplicates O(N) ~ O(2N) ~ O(N + N)
                public void RemoveDups()
                {
                    _markDuplicate();
                    if (countOfDup == 0) return; //no duplicate
                    int temp = 0;
    
                    for (int i = 0; i < _leght; i++)
                    {
                        // if duplicate remember and continue
                        if (_arr[i] == Int32.MinValue) continue;
                        else //else need move 
                        {
                            if (temp != i) _arr[temp] = _arr[i];
                            temp++;
                        }
                    }
                    _leght -= countOfDup;
                }
            }
    

    And Main

    static void Main(string[] args)
    {
         Random r = new Random(DateTime.Now.Millisecond);
         int i = 11;
         MyArray a = new MyArray(i);
         for (int j = 0; j < i; j++)
         {
            a.Insert(r.Next(i - 1));
         }
    
         a.Display();
         Console.Out.WriteLine();
         a.InsertSort();
         a.Display();
         Console.Out.WriteLine();
         a.RemoveDups();
         a.Display();
    
        Console.ReadKey();
    }
    
    0 讨论(0)
  • 2020-11-27 16:49

    Use a Set implementation.
    HashSet,TreeSet or LinkedHashSet if its Java.

    0 讨论(0)
  • 2020-11-27 16:52

    Check every element against every other element

    The naive solution is to check every element against every other element. This is wasteful and yields an O(n2) solution, even if you only go "forward".

    Sort then remove duplicates

    A better solution is sort the array and then check each element to the one next to it to find duplicates. Choose an efficient sort and this is O(n log n).

    The disadvantage with the sort-based solution is order is not maintained. An extra step can take care of this however. Put all entries (in the unique sorted array) into a hashtable, which has O(1) access. Then iterate over the original array. For each element, check if it is in the hash table. If it is, add it to the result and delete it from the hash table. You will end up with a resultant array that has the order of the original with each element being in the same position as its first occurrence.

    Linear sorts of integers

    If you're dealing with integers of some fixed range you can do even better by using a radix sort. If you assume the numbers are all in the range of 0 to 1,000,000 for example, you can allocate a bit vector of some 1,000,001. For each element in the original array, you set the corresponding bit based on its value (eg a value of 13 results in setting the 14th bit). Then traverse the original array, check if it is in the bit vector. If it is, add it to the result array and clear that bit from the bit vector. This is O(n) and trades space for time.

    Hash table solution

    Which leads us to the best solution of all: the sort is actually a distraction, though useful. Create a hashtable with O(1) access. Traverse the original list. If it is not in the hashtable already, add it to the result array and add it to the hash table. If it is in the hash table, ignore it.

    This is by far the best solution. So why the rest? Because problems like this are about adapting knowledge you have (or should have) to problems and refining them based on the assumptions you make into a solution. Evolving a solution and understanding the thinking behind it is far more useful than regurgitating a solution.

    Also, hash tables are not always available. Take an embedded system or something where space is VERY limited. You can implement an quick sort in a handful of opcodes, far fewer than any hash table could be.

    0 讨论(0)
  • 2020-11-27 16:54
    public class RemoveDuplicateArray {
        public static void main(String[] args) {
            int arr[] = new int[] { 1, 2, 3, 4, 5, 6, 7, 2, 3, 4, 9 };
            int size = arr.length;
            for (int i = 0; i < size; i++) {
                for (int j = i+1; j < size; j++) {
                    if (arr[i] == arr[j]) {
                        while (j < (size) - 1) {
                            arr[j] = arr[j + 1];
                            j++;
                        }
                        size--;
                    }
                }
            }
            for (int i = 0; i < size; i++) {
                System.out.print(arr[i] + "  ");
            }
        }
    
    }
    

    output - 1 2 3 4 5 6 7 9

    0 讨论(0)
提交回复
热议问题